config/routes.rb
Rails.application.routes.draw do
  devise_for :admins
    resources :products
    resources :cashiers
  
  root 'cashiers#home'
  
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
         
  has_many :products
  has_many :cashiers
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cashier.rb
class Cashier < ApplicationRecord
    belongs_to :admin
end

app/models/product.rb
class Product < ApplicationRecord
    belongs_to :admin
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  
  before_action :authenticate_admin!
end

app/controllers/cashiers_controller.rb
class CashiersController < ApplicationController
    before_action :authenticate_admin! 
    def new
        @cashier = Cashier.new
    end
    
    def index
        @cashiers = Cashier.all
    end
    
    def edit
        @cashier = Cashier.find(params[:id])
        if @cashier.admin != current_admin
            redirect_to cashiers_path
        end
    end
    
    def update
        @cashier = Cashier.find(params[:id])
        @cashier.update(cashier_params)
        @cashier.save
        
        redirect_to cashier_path
    end
    
    def destroy
        @cashier = Cashier.find(params[:id])
        @cashier.destroy
        
        redirect_to cashiers_path
    end
    
    def create
      @cashier = Cashier.new(cashier_params)
      @cashier.admin = current_admin
      @cashier.inspect
      @cashier.save
    
        redirect_to @cashier
    end

    def show
        id = params[:id]
        @cashier = Cashier.find(id)
    end
    
    
    private
        def cashier_params
            params.require(:cashier).permit!
        end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
    before_action :authenticate_admin! 
    def new
        @product = Product.new
    end
    
    def index
        @products = Product.all
    end
    
    def edit
        @product = Product.find(params[:id])
        if @product.admin != nil
            @product = Product.find(params[:id])
        end
    end
    
    def update
        @product = Product.find(params[:id])
        @product.update(product_params)
        @product.save
        
        redirect_to product_path
    end
    
    def destroy
        @product = Product.find(params[:id])
        @product.destroy
        
        redirect_to products_path
    end
    
    def create
      @product = Product.new(product_params)
      @product.admin = current_admin
      @product.inspect
      @product.save
    
        redirect_to @product
    end

    def show
        id = params[:id]
        @product = Product.find(id)
    end
    
    
    private
        def product_params
            params.require(:product).permit!
        end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cashiers_helper.rb
module CashiersHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/cashiers/edit.html.erb
<h1> Edit Cashier </h1>

<div class="col-md-4 col-md-offset-4">
<%= simple_form_for @cashier do |f| %>
    <p>
        <%= f.input :name %>
    </p>
    <p>
        <%= f.input :status, :label => "Active?" %>
    </p>
    <%= f.submit %>
<% end %>
</div>

app/views/cashiers/home.html.erb
<h1 align="center">💸 Welcome to Cash me Ousside! 💸</h1>
<div class="col-md-3"></div>
<div class="col-md-6">
    <table class="table table-strip">
        <tr><td align="center"><strong>Cashier:</strong></td><td align="center"><strong>Product:</strong></td></tr>
        <tr>
           <td align="center"><%= link_to "Cashier List", cashiers_path %></td>
           <td align="center"><%= link_to "Products List", products_path %></td> 
        </tr>
        <tr>
           <td align="center"><%= link_to "Add Cashier", new_cashier_path %></td>
           <td align="center"><%= link_to "Add Product", new_product_path %></td> 
        </tr>
    </table>
</div>
<div class="col-md-3"></div>

app/views/cashiers/index.html.erb
<div class="container" style = "padding-top: 50px">
	<div class="page-header">
		<h1 class="text-center">Cashiers</h1>
	</div>
</div>
<div class="container">

<table class="table table-strip">
    <tr><th></th><th>Name</th><th>Price</th><th>Status</th><th>Created by:</th></tr>
    <% @cashiers.each_with_index do |f, i| %>
        <tr>
           <td><%= (i+1) %></td>
           <td><%= f.name %></td>
           <td><%= if f.status == true then 'Active' else 'Inactive' end %></td>
           <td><%= if f.admin then f.admin.email else 'N/A' end %></td>
           <td><%= link_to "Show Cashier Information", cashier_path(f) %></td>
        </tr>
    <% end %>
</table>

 

app/views/cashiers/new.html.erb
<h1>New Cashier</h1>

<div class="col-md-4 col-md-offset-4">
<%= simple_form_for @cashier do |f| %>
    <p>
        <%= f.input :name %>
    </p>
    <p>
        <%= f.input :status, :label => "Active?" %>
    </p>
    <%= f.submit %>
<% end %>
</div>

app/views/cashiers/show.html.erb
<h1>Cashier Profile</h1>

<h3> Cashier ID: <%= @cashier.id %> </h3>
<h3> Name: <%= @cashier.name %></h3>
<h3> Status: <%= if @cashier.status == true then 'Active' else 'Inactive' end %></h3>

<%= link_to "Add New Cashier", new_cashier_path %> <br>
<%= link_to "Back to Cashiers", cashiers_path %> <br>
<%= link_to "Edit Cashier Profile", edit_cashier_path(@cashier) %> <br>
<%= link_to "Delete Product", cashier_path, method: :delete, data: {confirm: "Are you sure?"} %> <br>

app/views/layouts/_navbar.html.erb
<nav class="navbar navbar-default">
  <div class="container-fluid">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header" style = "color: #607d8b blue-grey">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <a class="navbar-brand" href="">Point of Sale</a>
    </div>
    <!-- Collect the nav links, forms, and other content for toggling -->
    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
      <ul class="nav navbar-nav">
        <li><a style="padding: 0px"><%= link_to "Products", products_path %><span class="sr-only">(current)</span></a></li>
        <li><a style="padding: 0px"><%= link_to "Cashiers", cashiers_path %></a></li>
      </ul>
      <p class="navbar-text pull-right">
      <% if admin_signed_in? %>
        Logged in as <strong><%= current_admin.email %></strong>.
        <%= link_to 'Edit profile', edit_admin_registration_path, :class => 'navbar-link' %> |
        <%= link_to "Logout", destroy_admin_session_path, method: :delete, :class => 'navbar-link'  %>
      <% else %>
        <%= link_to "Sign up", new_admin_registration_path, :class => 'navbar-link'  %> |
        <%= link_to "Login", new_admin_session_path, :class => 'navbar-link'  %>
      <% end %>
      </p>
      <form action"" class="navbar-form navbar-right" role="search">
				<div class="form-group">
					<input type="text" class="form-control" placeholder="Search">
				</div>
				<a type="search" class="btn btn-inverse"><span class="glyphicon glyphicon-search"></span></a>
			</form>	
 
      
      
    </div><!-- /.navbar-collapse -->
  </div><!-- /.container-fluid -->
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Workspace</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    
  </head>

  <body>
    <%= render 'layouts/navbar' %>
    <div class="container">
      <% if notice %>
        <p class="alert alert-success"><%= notice %></p>
      <% end %>
      <% if alert %>
        <p class="alert alert-danger"><%= alert %></p>
      <% end %>
      <%= yield %>
    </div>
  </body>
</html>

app/views/products/edit.html.erb
<h1> Edit Product </h1>
<div class="col-md-4 col-md-offset-4">
<%= simple_form_for @product do |f| %>
    <p>
        <%= f.input :name %>
    </p>
    <p>
        <%= f.input :price %>
    </p>
    <p>
        <%= f.input :status, :label => "Active?" %>
    </p>
    <%= f.submit %>
<% end %>
</div>

app/views/products/index.html.erb
<div class="container" style = "padding-top: 50px">
	<div class="page-header">
		<h1 class="text-center">Products</h1>
	</div>
</div>
<div class="container">
<table class="table table-strip">
    <tr><th></th><th>Name</th><th>Price</th><th>Status</th><th>Created by:</th><th></th></tr>
    <% @products.each_with_index do |f, i| %>
        <tr>
           <td><%= (i+1) %></td>
           <td><%= f.name %></td>
           <td><%= f.price %></td>
           <td><%= if f.status == true then 'Active' else 'Inactive' end %></td>
           <td><%= if f.admin then f.admin.email else 'N/A' end %></td>
           <td><%= link_to "Show Product Details", product_path(f) %></td>
          
        </tr>
    <% end %>
</table>
</div>

 

app/views/products/new.html.erb
<h1>New Product</h1>

<div class="col-md-4 col-md-offset-4">
<%= simple_form_for @product do |f| %>
    <p>
        <%= f.input :name %>
    </p>
    <p>
        <%= f.input :price %>
    </p>
    <p>
        <%= f.input :status, :label => "Active?" %>
    </p>
    <%= f.submit %>
<% end %>
</div>

app/views/products/show.html.erb
<h1>Product Information</h1>

<h3> Product ID: <%= @product.id %> </h3>
<h3> Name: <%= @product.name %></h3>
<h3> Price: <%= @product.price %></h3>
<h3> Status: <%= if @product.status == true then 'Active' else 'Inactive' end %></h3>

<%= link_to "Add Another Product", new_product_path %> <br>
<%= link_to "Back to Products", products_path %> <br>
<%= link_to "Edit Product Info", edit_product_path(@product) %> <br>
<%= link_to "Delete Product", product_path, method: :delete, data: {confirm: "Are you sure?"} %> <br>